<template>
	<main v-if="validity === Validity.Ok">
		<h1>Email address confirmed</h1>
		<p>You have successfully added this email address to your Vault account.</p>
		<p>You may now close this tab.</p>
	</main>
	<main v-else-if="validity === Validity.Invalid">
		<h1>Invalid link</h1>
		Your email validation link is invalid. Make sure you copied the full URL that was sent to you by email.
	</main>
	<main v-else-if="validity === Validity.Expired">
		<h1>Expired link</h1>
		Your email validation link has expired.
	</main>
	<main v-else-if="validity === Validity.Error">
		<h1>Error</h1>
		<pre>{{ error }}</pre>
		<p>Please try again later. If the problem persists, contact <a rel="noopener noreferrer" href="https://www.themanaworld.org/support">Support</a>.</p>
	</main>
	<main v-else-if="validity === Validity.IP">
		<h1>IP address mismatch</h1>
		<p>The IP address that was used to initiate the email validation process differs from your current IP address.</p>
		<p>NOTE: You can disable this security feature in your account settings (not recommended).</p>
	</main>
	<main v-else-if="validity === Validity.Email">
		<h1>Please confirm your email address</h1>
		<p>To continue, you must re-enter the email address to which this validation link was sent.</p>
		<br>
		<form class="gap-no read_s login" @submit.prevent="checkToken">
			<div class="form-box pa_m">
				<label for="email" class="mini-label">Re-enter your email address</label>
				<input v-focus required autocorrect="off" name="email" id="email" ref="email" v-model="email" type="email" placeholder="your@email.com" class="input text_l pa_m">
			</div>
			<button class="button block text_l pa_s" type="submit" ref="submit">Verify &rarr;</button>
		</form>
	</main>
	<main v-else>
		<h1>Please wait</h1>
		Verifying your validation link...
	</main>
</template>

<script lang="ts">
import { Vue, Component } from "vue-property-decorator"
import { REGEXES } from "@/types"

enum Validity {
	Init,     // initial state
	Ok,       // confirmed
	Invalid,  // malformed
	IP,       // ip changed
	Email,    // ask to provide email
	Expired,  // expired link
	Error,    // misc error
}

@Component({
	data () {
		return { Validity }
	},
})
export default class Auth extends Vue {
	validity: Validity = Validity.Init
	error = ""
	email = ""
	token = ""

	async created () {
		this.token = this.$route.hash.slice(1)

		if (Reflect.has(this.$route.params, "key")) {
			this.token = this.$route.params.key
		}

		if (this.token.length < 1 || (!REGEXES.UUID.test(this.token) && !REGEXES.NANO.test(this.token))) {
			this.validity = Validity.Invalid
			return
		}

		if (this.$store.getters.loginAttemptValid()) {
			this.email = this.$store.state.loginAttempt.email
			return await this.checkToken()
		}

		// else ask to provide the email again
		this.validity = Validity.Email
	}

	async checkToken () {
		const req = new Request(`${process.env.VUE_APP_API}/vault/identity`, {
			method: "POST",
			mode: "cors",
			cache: "no-cache",
			redirect: "follow",
			referrer: "no-referrer",
			headers: {
				"Accept": "application/json",
				"Content-Type": "application/json",
				"X-VAULT-TOKEN": this.token,
			},
			body: JSON.stringify({
				email: this.email,
			}),
		})

		let rawResponse

		try {
			rawResponse = await fetch(req)
		} catch (err) {
			this.validity = Validity.Error
			this.error = "Couldn't reach the API"
			console.error(err)
			return
		}
		const json = await rawResponse.json()

		switch (rawResponse.status) {
		case 201:
			this.validity = Validity.Ok

			// this loginAttempt has expired now
			this.$store.commit("setLoginAttempt", "")

			if (Reflect.has(json, "identities")) {
				this.$store.commit("setIdentities", json.identities)
			} else if (Reflect.has(json, "identity")) {
				this.$store.commit("pushIdentity", json.identity)
			}

			// redirect
			if (Reflect.has(this.$route.params, "redirect")) {
				this.$router.replace({name: this.$route.params.redirect})
			} else if (Reflect.has(this.$route.query, "redirect")) {
				this.$router.replace({name: this.$route.query.redirect as string})
			}
			return
		case 400:
			this.validity = Validity.Error
			this.error = "Malformed request"
			return
		case 403:
			this.validity = Validity.IP
			this.error = "IP address mismatch"
			return
		case 410:
			this.validity = Validity.Expired
			return
		case 418:
			this.validity = Validity.Error
			this.error = "You Shall Not Pass!"
			return
		//case 425:
		case 429:
			this.validity = Validity.Error
			this.error = "Too many requests"
			return
		case 500:
			this.validity = Validity.Error
			this.error = "Internal server error"
			return
		case 502:
			this.validity = Validity.Error
			this.error = "The API is unreachable"
			return
		default:
			this.validity = Validity.Error
			this.error = `Unknown error: ${rawResponse.status}`
			return
		}
	}
}
</script>
